/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
 * All rights reserved.</center></h2>
 *
 * This software component is licensed by ST under BSD 3-Clause license,
 * the "License"; You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at:
 *                        opensource.org/licenses/BSD-3-Clause
 *
 ******************************************************************************
 */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

#define	TRAP		__NOP()


/*
#define	MAX_ZKRES		0			// Liczba używanych zakresow pomiarowych
#define	TXT_ZAKRES_0		"30"	// Symbol zakresu 0
#define	TXT_JEDNOSTKA_0		"C"		// Jednostka zakresu 0
*/
/*
#define	MAX_ZKRES		0			// Liczba używanych zakresow pomiarowych
#define	TXT_ZAKRES_0		"300"	// Symbol zakresu 0
#define	TXT_JEDNOSTKA_0		"V"		// Jednostka zakresu 0
*/
#define	AUTO_ON						// Zakomentowanie wyłaczy automatykę oraz ustawi najwyższy zakres pomiarowy
#define	MAX_ZKRES		2			// Liczba używanych zakresów pomiarowych
#define	TXT_ZAKRES_0		"1000"	// Symbol zakresu 0
#define	TXT_JEDNOSTKA_0		"mV"	// Jednostka zakresu 0
#define	TXT_ZAKRES_1		"10"	// Symbol zakresu 1
#define	TXT_JEDNOSTKA_1		"V"
#define	TXT_ZAKRES_2		"100"	// Symbol zakresu 2
#define	TXT_JEDNOSTKA_2		"V"
#define	TXT_ZAKRES_3		"1kV"	// Symbol zakresu 3
#define	TXT_JEDNOSTKA_3		"V"


#define	POMIAR_ADC		0			// Z którego ADC dokonywane są pomiary. 0-adc1, 1-SDadc1
#define	VREF_VCC 		3.2984 		// Napięcie zasilania uC
#define	VREF_SDADC 		1.2288 		// Vref adc 16-bit


//#define	D_WE_0			30
//#define	D_WE_0			300
#define	D_WE_0			1
#define	D_WE_1			11
#define	D_WE_2			101
#define	D_WE_3			1001


#define	KALIBRACJA_DZIELNIKA_0		1.05386416861827		// 900 / 854
#define	KALIBRACJA_DZIELNIKA_1		1.08481262327416		// 5.5 / 5.07
#define	KALIBRACJA_DZIELNIKA_2		1.0
#define	KALIBRACJA_DZIELNIKA_3		1.0
//Sposob kalibracji:
// KALIBRACJA_DZIELNIKA	= 1.0
// Ustawić Vin 900mV
// Odczytac pomiar np 790mV
// 900 / 790 = 1,13924050632911
// Powrórzyć dla wszystkich zakresów


//#define	SKALA_KOLOR					// Definiacja włacza kolorową skalę
#define	KAT_SKALI_GORA			20.0
#define	KAT_SKALI_DOL			30.0

#define	KOLOR_SKALI_GORA		ANSI_RED
#define	KOLOR_SKALI_SRODEK		ANSI_GREEN
#define	KOLOR_SKALI_DOL			ANSI_YELLOW


//#define	DIGITAL_KOLOR				// Definicja włącza kolorowy wskaźnik cyforwy
#define	WSKAZANIE_ZAKRES_KOLOR_Y	200
#define	WSKAZANIE_ZAKRES_KOLOR_G	205
#define	WSKAZANIE_ZAKRES_KOLOR_R	250


const char _name[] = "Analog Meter";
const char _name1[] = "Analog";
const char _name2[] = "Meter";
const char _ver[] = "v1.0 rev2001";
const char _date_time[] = __DATE__" "__TIME__;
const char _auth[] = "(C)AVT, SaS";
const char _email[] = "sas@elportal.pl";
const char _prawa1[] = "Wszelkie prawa";
const char _prawa2[] = 	" zastrzezone!";
const char _prawa3[] = "Tylko na własny uzytek.";
const char _prawa4[] = "Rozpowrzechnianie ";
const char _prawa5[] = "wymaga zgody autora.";

//------------------------------------------------------------------------------


#include "math.h"
#include "string.h"


#include "../lcd/ansi.h"
#include "../lcd/def.h"
#include <stdio.h>      /* printf */

#include "../lcd/graph.h"
#include "../lcd/IL9163.h"


/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
ADC_HandleTypeDef hadc1;

IWDG_HandleTypeDef hiwdg;

SDADC_HandleTypeDef hsdadc1;

SPI_HandleTypeDef hspi1;
DMA_HandleTypeDef hdma_spi1_tx;

TIM_HandleTypeDef htim12;

UART_HandleTypeDef huart2;
DMA_HandleTypeDef hdma_usart2_tx;

/* USER CODE BEGIN PV */


uint8_t init_fine;
uint16_t volatile PomiarAdc1;
int32_t PomiarSDadc1, PomiarSDadc2;
float NapiecieAdc1, NapiecieSDadc1, NapiecieSDadc2;

u32 serialNO;//, id_cpu[3];
u8 crcSN;

const uint8_t gamma256_correction[] = {
		0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,				// Tu byly tylko zera
		1,1,1,1,1,1,1,2,2,2,2,2,3,3,3,3,4,4,		// Od tad pojawila sie jedynka
		4,4,5,5,5,5,6,6,6,7,7,7,8,8,9,9,
		9,10,10,10,11,11,12,12,13,13,14,
		14,15,15,16,16,17,17,18,18,19,19,20,20,21,21,22,
		23,23,24,25,25,26,26,27,28,28,29,30,30,31,32,33,
		33,34,35,36,36,37,38,39,39,40,41,42,43,43,44,45,46,
		47,48,49,49,50,51,52,53,54,55,56,57,58,59,60,61,
		62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,
		78,79,81,82,83,84,85,86,87,89,90,91,92,93,95,96,
		97,98,100,101,102,103,105,106,
		107,108,110,111,112,114,115,116,
		118,119,121,122,123,125,126,127,
		129,130,132,133,135,136,138,139,
		141,142,144,145,147,148,150,151,
		153,154,156,157,159,160,162,164,
		165,167,169,170,172,173,175,177,
		178,180,182,183,185,187,189,190,
		192,194,196,197,199,201,203,204,
		206,208,210,212,213,215,217,219,
		221,223,225,226,228,230,232,234,
		236,238,240,242,244,246,248,250,
		252,255,255
};


/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_DMA_Init(void);
static void MX_ADC1_Init(void);
static void MX_IWDG_Init(void);
static void MX_SPI1_Init(void);
static void MX_TIM12_Init(void);
static void MX_USART2_UART_Init(void);
static void MX_SDADC1_Init(void);
/* USER CODE BEGIN PFP */

uint16_t volatile timAutoZakres, timinitLcd = 4000, timPomiar = 10000;
uint64_t volatile TimSys;
void irq1ms(void);

uint16_t dzielWej;
#ifdef AUTO_ON
uint8_t AutoOff, Zakres = MAX_ZKRES;		// todo: test:
#else
uint8_t AutoOff = 1, Zakres = 0;
#endif
void dzielnikWejsciowy( uint8_t div );
void AutoZakres();
void ZakresUp();
void ZakresDown();


/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */


//------------------------------------------------------------------//
void irq1ms(){
	TimSys++;


	if( timPomiar ) timPomiar--;
	if( timinitLcd ) timinitLcd--;
	if( timAutoZakres ) timAutoZakres--;


	uint8_t static dir, div, pwm;
	if( init_fine && !(++div % 4) ){	// Gdy TIM12 skonfigurowany, co 4 przerwania, zmieniaj jasność led
		if( ! dir ){
			if( pwm < 254 ) __HAL_TIM_SET_COMPARE(&htim12, TIM_CHANNEL_2, gamma256_correction[pwm++] ); else dir ^= 1;
		}
		else{
			if( pwm > 0 ) __HAL_TIM_SET_COMPARE(&htim12, TIM_CHANNEL_2, gamma256_correction[pwm--] ); else dir ^= 1;
		}
	}
}


//------------------------------------------------------------------//
uint64_t readTimSys(){
	HAL_NVIC_DisableIRQ( SysTick_IRQn );	//	 __disable_irq();
	uint64_t t = TimSys;
	HAL_NVIC_EnableIRQ( SysTick_IRQn );		// __enable_irq();
	return t;
}


//------------------------------------------------------------------//
void dzielnikWejsciowy( uint8_t z ){
	Zakres = z;


	if( z == 0 ){
		HAL_GPIO_WritePin(D10_GPIO_Port, D10_Pin, GPIO_PIN_SET);
		HAL_GPIO_WritePin(D100_GPIO_Port, D100_Pin, GPIO_PIN_SET);
		HAL_GPIO_WritePin(D1000_GPIO_Port, D1000_Pin, GPIO_PIN_SET);
		dzielWej = D_WE_0;
	}
	else if( z == 1 ){
		HAL_GPIO_WritePin(D10_GPIO_Port, D10_Pin, GPIO_PIN_RESET);
		HAL_GPIO_WritePin(D100_GPIO_Port, D100_Pin, GPIO_PIN_SET);
		HAL_GPIO_WritePin(D1000_GPIO_Port, D1000_Pin, GPIO_PIN_SET);
		dzielWej = D_WE_1;
	}
	else if( z == 2 ){
		HAL_GPIO_WritePin(D10_GPIO_Port, D10_Pin, GPIO_PIN_SET);
		HAL_GPIO_WritePin(D100_GPIO_Port, D100_Pin, GPIO_PIN_RESET);
		HAL_GPIO_WritePin(D1000_GPIO_Port, D1000_Pin, GPIO_PIN_SET);
		dzielWej = D_WE_2;
	}
	else {
		HAL_GPIO_WritePin(D10_GPIO_Port, D10_Pin, GPIO_PIN_SET);
		HAL_GPIO_WritePin(D100_GPIO_Port, D100_Pin, GPIO_PIN_SET);
		HAL_GPIO_WritePin(D1000_GPIO_Port, D1000_Pin, GPIO_PIN_RESET);
		dzielWej = D_WE_3;
	}
}


//------------------------------------------------------------------//
void ZakresUp(){
	if( Zakres < MAX_ZKRES ) Zakres++;
	dzielnikWejsciowy( Zakres );
}


void ZakresDown(){
	if( Zakres > 0 ) Zakres--;
	dzielnikWejsciowy( Zakres );
}



//------------------------------------------------------------------//
float wartDlaAuto;

void AutoZakres(){

	if( timAutoZakres || AutoOff ) return;
	timAutoZakres = 1000;


#if POMIAR_ADC == 0
	//if( PomiarAdc1 > 640 ) ZakresUp();
	//if( PomiarAdc1 < 10 ) ZakresDown();
	if( wartDlaAuto >= 1.0 ) ZakresUp();
	if( wartDlaAuto < 0.03 ) ZakresDown();
#elif POMIAR_ADC == 1
	if( PomiarSDadc1 < 2500 ) ZakresDown();
	if( PomiarSDadc1 > 30000 ) ZakresUp();
#else
#error "Brak wyboru"
#endif
	TRAP;
}


//------------------------------------------------------------------//
void ErrorDisplay( uint8_t* txt1, uint8_t* txt2, uint8_t* txt3 ){
	TFT_ILI9163C_SetFont( 16, 16 );
	TFT_ILI9163C_PrintString_P( 0, 32, (char*)txt1, ANSI_RED );
	TFT_ILI9163C_PrintString_P( 0, 32+16, (char*)txt1, ANSI_RED );
	TFT_ILI9163C_PrintString_P( 0, 32+16, (char*)txt1, ANSI_RED );
	TFT_ILI9163C_Display();	// TFT_ILI9163C_DisplayDMA();
}


//------------------------------------------------------------------//
// confParam contains the channel configuration
//SDADC_ConfParamTypeDef confParam;
//SDADC_HandleTypeDef hsdadc;
// InjChannel contains the converted channel after each conversion. This is not used in this example.
__IO uint32_t InjChannel = 0;
uint32_t InjectedConvData;
void HAL_SDADC_InjectedConvCpltCallback(SDADC_HandleTypeDef *hsdadc)
{
	/* Get conversion value */
	InjectedConvData = HAL_SDADC_InjectedGetValue(hsdadc, (uint32_t *) &InjChannel);
	TRAP;
}


uint64_t volatile timPomSDadc;
//------------------------------------------------------------------//
void irqSDadc(){
	uint32_t static t;

#define L_POM_SDADC	4096
	uint16_t static cnt = L_POM_SDADC;
	uint32_t static mem;
	mem += HAL_SDADC_GetValue(&hsdadc1);
	HAL_ADC_Start(&hadc1);
	if( --cnt == 0 ){
		cnt = L_POM_SDADC;
		PomiarSDadc1 = mem / L_POM_SDADC;
		if( PomiarSDadc1 > 65000 ) {
			PomiarSDadc1 = 65535;	// Przekroczenie zakresu
			TRAP;
		}
		else{
			PomiarSDadc1 -= 32768;
			PomiarSDadc1 -= 150;	// todo: ofset
			if( PomiarSDadc1 < 0 ) PomiarSDadc1 = 0; // Gdy przekroczony zakres od dolu
		}
		mem = 0;
		timPomSDadc = TimSys - t;
		t = TimSys;
	}
}


//------------------------------------------------------------------//
//x i y to wspł. środka, r - średnica, p - długość wskazówki jako procent średnicy lub w wersji 5 szerokosc skali, minVal i maxVal - min i max wartości, t - wersja wyświetlania
void Drawgauge(int x, byte y, byte r, byte p, int v, int minVal, int maxVal,  byte t ) {
	int n = (r / 100.00) * p; // oblicza długość wskazówki

	switch (t) { //switchem obsługuję różne wersje wyświetlania
	case 5: { //górna połowa z wypełnieniem
		int ns;
		int szer = p; //szerokość skali w px
		float gs_rad = -1.572;
		float ge_rad = 1.572;
		n = r - 1;
		ns = r - szer;
		TFT_ILI9163C_drawCircle(x, y, r, DRAW_UPPER_LEFT, ANSI_CYAN ); //skala zewn
		TFT_ILI9163C_drawCircle(x, y, r - szer, DRAW_UPPER_LEFT, ANSI_CYAN ); //skala wewn
		TFT_ILI9163C_drawLine(x - r, y, x - r + (szer + 3), y, ANSI_WHITE ); //linia skali na min
		TFT_ILI9163C_drawLine(x + r, y, x + r - (szer + 3), y, ANSI_BLUE ); //linia skali na max
		TFT_ILI9163C_drawLine(x, y - r, x, y - r + (szer + 3), ANSI_GREEN ); //linia skali na polowie
		for (int k = 1; k <= v; k++) //wyswietlanie wypelnienia skali jaki wiele linii obok siebie
		{
			float i = ((k - minVal) * (ge_rad - gs_rad) / (maxVal - minVal) + gs_rad);
			int xp = x + (sin(i) * n); //x punktu konca linii
			int yp = y - (cos(i) * n); //y punktu konca linii
			int xs = x + (sin(i) * ns); //x punktu poczatku linii
			int ys = y - (cos(i) * ns); //y punktu poczatku linii
			TFT_ILI9163C_drawLine(xs, ys, xp, yp, ANSI_MAGNETA ); //linia wypełniająca skalę
		}

	}
	break;
	}
}


//------------------------------------------------------------------//
void drawCircleKolor(int x0, int y0, uint8_t rad, uint16_t color ) {
	int_fast16_t f;
	int_fast16_t ddF_x;
	int_fast16_t ddF_y;
	int_fast16_t x;
	int_fast16_t y;

	f = 1;
	f -= rad;
	ddF_x = 1;
	ddF_y = 0;
	ddF_y -= rad;
	ddF_y *= 2;
	x = 0;
	y = rad;

	while (x<y)	{
		if (f >= 0) {
			y--;
			ddF_y += 2;
			f += ddF_y;
		}
		x++;
		ddF_x += 2;
		f += ddF_x;
#ifdef SKALA_KOLOR
		float phi = acos(-x/(float)rad*1.0)*180/M_PI*2.0-180.0; //przyjmuje wartosci od 0 do 90
#endif
		/*
 //----- Skala obustronnie kolorowa, red, yellow, green, green, yellow, red -----//
		if(phi<=30.0) color = ANSI_RED; //red
		else if(phi<=60.0) color = ANSI_YELLOW; //red
		else if(phi<=91.0) color = ANSI_GREEN; //green
		TFT_ILI9163C_drawPixel( x0 - x, y0 - y,color); //rysuj punkt o podanych współrzędnych.
		TFT_ILI9163C_drawPixel( x0 - y, y0 - x,color); //rysuj punkt o podanych współrzędnych
		 */
		//----- Skala jednostronnie kolorowa, yellow, green, red -----//
#ifdef SKALA_KOLOR
		if (phi<=KAT_SKALI_GORA) color = KOLOR_SKALI_GORA; // 60 stopni górnej ćwiarki skali (koncowka skali)
		else if(phi<=91.0) color = KOLOR_SKALI_SRODEK; // 90 stopni górnej ćwiarki skali (środek skali)
#endif
		TFT_ILI9163C_drawPixel( x0 - x, y0 - y,color); //rysuj punkt o podanych współrzędnych.
#ifdef SKALA_KOLOR
		if(phi<=KAT_SKALI_DOL) color = KOLOR_SKALI_DOL; // 60 stopni dolnej cwiartki skali (dół skali)
		else if(phi<=91.0) color = KOLOR_SKALI_SRODEK; // 90 stopni dolnej cwiartki skali (środek skali)
#endif
		TFT_ILI9163C_drawPixel( x0 - y, y0 - x,color); //rysuj punkt o podanych współrzędnych
	}
}


//------------------------------------------------------------------//
void PrintWskaznik( float wartosc ){
	const int16_t r = 110, skala = 20, sx = _GRAMWIDTH-5, sy = _GRAMHEIGH-1;
	const uint16_t kolSkala = ANSI_WHITE, kolSkalaPolowki = ANSI_CYAN, kolWskazowa = ANSI_CYAN, kolSkalaSkraj = ANSI_BLACK;


	wartosc *= 0.97;		// Korekta aby dla 1 wskazówka była pionowo


	//----- Skala -----//
	for(char p=0; p<skala+1; p++){		// 20 działek
		float war = p * 0.05;
		float fi = war * M_PI / 2;
		int16_t x1 = (r+8) * cos( fi );
		int16_t y1 = (r+8) * sin( fi );
		uint16_t x0, y0, color = kolSkala;
		if ( p & 1 ){
			x0 = (r) * cos( fi );
			y0 = (r) * sin( fi );
			color = kolSkalaPolowki;
		}
		else{
			x0 = (r-5) * cos( fi );
			y0 = (r-5) * sin( fi );
		}
		//----- Grubsze kreski...
		color = kolSkala;
		if( p == 0 ){				// na poczatku
			color = kolSkalaSkraj;
			TFT_ILI9163C_drawLine(sx-x0, sy-y0-1, sx-x1, sy-y1-1, kolSkalaSkraj );
		}
		else if( p == skala/2 ){	// w polowie
			color = kolSkalaSkraj;
			TFT_ILI9163C_drawLine(sx-x0-1, sy-y0, sx-x1-1, sy-y1, kolSkalaSkraj );
		}
		else if( p == skala ){		// i na koncu skali
			color = kolSkalaSkraj;
			TFT_ILI9163C_drawLine(sx-x0-1, sy-y0, sx-x1-1, sy-y1, kolSkalaSkraj );
		}
		TFT_ILI9163C_drawLine(sx-x0, sy-y0, sx-x1, sy-y1, color );	// Skala
	}


	drawCircleKolor( sx, sy, r+10, kolSkala ); // TFT_ILI9163C_drawCircle( sx, sy, r+8, DRAW_UPPER_LEFT, kolSkala );
	drawCircleKolor( sx, sy, r+9, kolSkala ); // TFT_ILI9163C_drawCircle( sx, sy, r+8, DRAW_UPPER_LEFT, kolSkala );
	drawCircleKolor( sx, sy, r+8, kolSkala ); // TFT_ILI9163C_drawCircle( sx, sy, r+8, DRAW_UPPER_LEFT, kolSkala );
	drawCircleKolor( sx, sy, r+7, kolSkala ); // TFT_ILI9163C_drawCircle( sx, sy, r+7, DRAW_UPPER_LEFT, kolSkala );
	drawCircleKolor( sx, sy, r+6, kolSkala ); //TFT_ILI9163C_drawCircle( sx, sy, r+2, DRAW_UPPER_LEFT, kolSkala );


	//----- Wskazowka -----//
	float fi = wartosc * M_PI / 2;
	int16_t x = (r-8) * cos( fi );
	int16_t y = (r-8) * sin( fi );
	TFT_ILI9163C_drawLine( sx, sy, _GRAMWIDTH-1-x, _GRAMHEIGH-1-y, kolWskazowa );
	if( fi < 0.5 || fi > 1){		// Gdy kat wskazowki duzo mniejszy lub wiekszy kat niz 45 stopni
		TFT_ILI9163C_drawLine( sx-1, sy-1, _GRAMWIDTH-2-x, _GRAMHEIGH-2-y, kolWskazowa );
		TFT_ILI9163C_drawLine( sx-2, sy-2, _GRAMWIDTH-3-x, _GRAMHEIGH-3-y, kolWskazowa );
	}
	else{							// kat wskazowki w poblizu polowy skali
		TFT_ILI9163C_drawLine( sx, sy-1, _GRAMWIDTH-x, _GRAMHEIGH-2-y, kolWskazowa );
		TFT_ILI9163C_drawLine( sx, sy-2, _GRAMWIDTH-x, _GRAMHEIGH-3-y, kolWskazowa );
	}


	//	char txt[50];
	//	sprintf( txt, "fi=%f", fi  );
	//	TFT_ILI9163C_PrintString_BP( 40, 64+32, (char*)txt, ANSI_MAGNETA, IL9163_BLACK );
}


//------------------------------------------------------------------//
struct flagi{
	uint8_t Iwdg: 1;
	uint8_t Por: 1;
} flagi;


//------------------------------------------------------------------//



/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */


	//----- Zatrzymuj IWDG podczas debugowania -----//
	__HAL_DBGMCU_FREEZE_IWDG(); // DBGMCU -> APB1FZ |= DBGMCU_APB1_FZ_DBG_IWDG_STOP;

	//----- Nie rozlaczaj z debugerem po usypieniu, stop, itp
	DBGMCU->CR |= DBGMCU_CR_DBG_SLEEP | DBGMCU_CR_DBG_STOP | DBGMCU_CR_DBG_STANDBY;   //


	// __HAL_DBGMCU_FREEZE_TIM1();
	// __HAL_DBGMCU_FREEZE_TIM2();
	//__HAL_DBGMCU_FREEZE_TIM12();


	//----- Flagi resetu -----//
	//RCC_CSR_OBLRSTF)))  /*!< Options bytes loading reset flag */
	//RCC_CSR_PINRSTF)))  /*!< PIN reset flag */
	//RCC_CSR_PORRSTF)))  /*!< POR/PDR reset flag */
	//RCC_CSR_SFTRSTF)))  /*!< Software Reset flag */
	//RCC_CSR_IWDGRSTF))) /*!< Independent Watchdog reset flag */
	//RCC_CSR_WWDGRSTF))) /*!< Window watchdog reset flag */
	//RCC_CSR_LPWRRSTF))) /*!< Low-Power reset flag */
	if ( RCC->CSR & RCC_CSR_IWDGRSTF ) flagi.Iwdg = true;
	if ( RCC->CSR & RCC_CSR_PORRSTF ) flagi.Por = true;
	__HAL_RCC_CLEAR_RESET_FLAGS();  // RCC->CSR |= RCC_CSR_RMVF;    // Kasuje flagi


  /* USER CODE END 1 */
  

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_ADC1_Init();
  MX_IWDG_Init();
  MX_SPI1_Init();
  MX_TIM12_Init();
  MX_USART2_UART_Init();
  MX_SDADC1_Init();
  /* USER CODE BEGIN 2 */


	TFT_ILI9163C_chipInit( 0 );
	TFT_ILI9163C_setRotation4dma( 3 ); // INFO: musi byc po "TFT_ILI9163C_chipInit" a "TFT_ILI9163C_chipInit" z rotation ustawionym na 0
	TFT_ILI9163C_clearScreen( ANSI_BLACK );
	//----- Numer seryjny -----//
	//HAL_GetUID(id_cpu);
	//serialNO = id_cpu[0] ^ id_cpu[1] ^ id_cpu[2];
	serialNO = HAL_GetUIDw0() ^ HAL_GetUIDw1() ^ HAL_GetUIDw2();
	crcSN = serialNO >> 24;
	crcSN += serialNO >> 16;
	crcSN += serialNO >> 8;
	crcSN += serialNO;
	{
		u8 pozY = 0 ;
		char txt[30];
		TFT_ILI9163C_SetFont( 16, 16 );
		//sprintf( txt, "SN=%4x:%04x", (unsigned int)(serialNO >> 16), (unsigned int)(serialNO & 0xFFFF) );
		//TFT_ILI9163C_PrintString_P( 0, pozY, (char*)txt, ANSI_WHITE, ANSI_BLACK );
		//pozY = TFT_ILI9163C_GetFontSizeY();

		uint8_t pozX = TFT_ILI9163C_PrintString_BP( 0, pozY, (char*)_name1, ANSI_WHITE, ANSI_BLUE );
		TFT_ILI9163C_PrintString_BP( pozX, pozY, (char*)_name2, ANSI_BLUE, ANSI_WHITE );
		pozY += TFT_ILI9163C_GetFontSizeY();

		TFT_ILI9163C_PrintString_P( 0, pozY, (char*)_ver, ANSI_YELLOW );
		pozY += TFT_ILI9163C_GetFontSizeY();

		TFT_ILI9163C_SetFont( 5, 7 );
		TFT_ILI9163C_PrintString_P( 0, pozY, (char*)_date_time, ANSI_WHITE );
		pozY += TFT_ILI9163C_GetFontSizeY();

		TFT_ILI9163C_SetFont( 16, 16 );
		TFT_ILI9163C_PrintString_P( 0, pozY, (char*)_auth, ANSI_CYAN );
		pozY += TFT_ILI9163C_GetFontSizeY();

		TFT_ILI9163C_SetFont( 5, 7 );
		TFT_ILI9163C_PrintString_BP( 0, pozY, (char*)_email, ANSI_BLACK, ANSI_WHITE );
		pozY += TFT_ILI9163C_GetFontSizeY();

		TFT_ILI9163C_SetFont( 5, 7 );
		pozY +=4;
		TFT_ILI9163C_PrintString_P( 0, pozY, (char*)_prawa1, ANSI_RED );
		pozY += TFT_ILI9163C_GetFontSizeY();
		TFT_ILI9163C_PrintString_P( 0, pozY, (char*)_prawa2, ANSI_RED );
		pozY += TFT_ILI9163C_GetFontSizeY();
		TFT_ILI9163C_PrintString_P( 0, pozY, (char*)_prawa3, ANSI_RED );
		pozY += TFT_ILI9163C_GetFontSizeY();
		TFT_ILI9163C_PrintString_P( 0, pozY, (char*)_prawa4, ANSI_RED );
		pozY += TFT_ILI9163C_GetFontSizeY();
		TFT_ILI9163C_PrintString_P( 0, pozY, (char*)_prawa5, ANSI_RED );
		pozY += TFT_ILI9163C_GetFontSizeY();


		// if ( serialNO != 0x7ecffe44 && serialNO != 0x7ecdfe4b ) {
		//   flFlashErr = true;
		//   TFT_ILI9163C_SetFont( 0x1632 );
		//   const char yc = TFT_ILI9163C_GetFontSizeY();
		//   TFT_ILI9163C_PrintString_BP( 0, _TFTHEIGHT / 2 - yc / 2, "FLASH Err", RED, BLACK );
		//  }

		if( flagi.Iwdg || flagi.Por ){
			TFT_ILI9163C_SetFont( 16, 16 );
			sprintf( txt, "Rst=%%%d%d", flagi.Iwdg, flagi.Por );
			TFT_ILI9163C_PrintString_BP( 0, pozY, (char*)txt, ANSI_RED, ANSI_BLACK );
		}
		TFT_ILI9163C_Display();	// TFT_ILI9163C_DisplayDMA();
	}


	HAL_TIM_Base_Start_IT(&htim12);		// LED RUN
	HAL_TIM_PWM_Start(&htim12, TIM_CHANNEL_2); // LED RUN

	HAL_ADC_Start(&hadc1);

/*
	TRAP;
	// Start Calibration in polling mode
	if (HAL_SDADC_CalibrationStart(&hsdadc1, SDADC_CALIBRATION_SEQ_1) != HAL_OK)
	{
		// An error occurs during the starting phase of the calibration
		ErrorDisplay((uint8_t*)"Fail to start the",(uint8_t*)"calibration",(uint8_t*)"");
	}
TRAP;
	// Pool for the end of calibration
	if (HAL_SDADC_PollForCalibEvent(&hsdadc1, HAL_MAX_DELAY) != HAL_OK)
	{
		// An error occurs while waiting for the end of the calibration
		ErrorDisplay((uint8_t*)"Fail to correctly",(uint8_t*)"calibrate SDADC",(uint8_t*)"");
	}
	TRAP;
	*/

	HAL_SDADC_Start_IT(&hsdadc1);


	dzielnikWejsciowy( Zakres );


  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */

	init_fine = true;
	// LOOP:
	while (1)
	{
		HAL_IWDG_Refresh(&hiwdg);
		__WFI();



		if (HAL_ADC_PollForConversion(&hadc1, 10) == HAL_OK) {
#define L_POM_ADC	8		// Petla glowna trwa 70ms. 10 pomiarow to 0,7 sekundy ! TODO: Aby wykonywac więcej pomiarów do uśrednienia przenieść na przerwania lub DMA
			uint8_t static cnt = L_POM_ADC;
			uint32_t static mem;
			mem += HAL_ADC_GetValue(&hadc1);
			HAL_ADC_Start(&hadc1);
			if( --cnt == 0 ){
				cnt = L_POM_ADC;
				PomiarAdc1 = mem / L_POM_ADC;
				mem = 0;
				NapiecieAdc1 = PomiarAdc1 * VREF_VCC / 4095;
			}
		}
		/*
		if (HAL_SDADC_PollForConversion(&hsdadc1, 10) == HAL_OK) {
			PomiarSDadc1 = HAL_SDADC_GetValue(&hsdadc1);
			NapiecieSDadc1 = PomiarSDadc1 * VREF_SDADC / 65535;				// (PomiarSDadc1 * VREF_SDADC) / (wzmocnienie * 65535);
			HAL_SDADC_Start(&hsdadc1);
		}
		 */

		/*
		if (HAL_SDADC_PollForConversion(&hsdadc2, 10) == HAL_OK) {
			PomiarSDadc2 = HAL_SDADC_GetValue(&hsdadc2);
			NapiecieSDadc2 = PomiarSDadc2 * VREF_SDADC / 65535;				// (PomiarSDadc2 * VREF_SDADC) / (wzmocnienie * 65535);
			HAL_SDADC_Start(&hsdadc2);
		}

		 */


		AutoZakres();


		if( ! timPomiar ){
			timPomiar = 150;


			if( ! timinitLcd ) {
				timinitLcd = 5000;

				TFT_ILI9163C_chipInit( 1 );
				TFT_ILI9163C_setRotation4dma( 3 ); // INFO: musi byc po "TFT_ILI9163C_chipInit" a "TFT_ILI9163C_chipInit" z rotation ustawionym na 0
			}



			TFT_ILI9163C_clearScreen( ANSI_BLUE );

			TFT_ILI9163C_SetFont( 16, 16 );
			uint8_t pozX = 0, pozY = 0;
			switch( Zakres ){
			case 0:
				pozX = TFT_ILI9163C_PrintString_P( pozX, pozY, TXT_ZAKRES_0, ANSI_YELLOW );
				TFT_ILI9163C_PrintString_P( pozX, pozY, TXT_JEDNOSTKA_0, ANSI_YELLOW );
				break;
			case 1:
				pozX = TFT_ILI9163C_PrintString_P( pozX, pozY, TXT_ZAKRES_1, ANSI_YELLOW );
				TFT_ILI9163C_PrintString_P( pozX, pozY, TXT_JEDNOSTKA_1, ANSI_YELLOW );
				break;
			case 2:
				pozX = TFT_ILI9163C_PrintString_P( pozX, pozY, TXT_ZAKRES_2, ANSI_YELLOW );
				TFT_ILI9163C_PrintString_P( pozX, pozY, TXT_JEDNOSTKA_2, ANSI_YELLOW );
				break;
			default:
				pozX = TFT_ILI9163C_PrintString_P( pozX, pozY, TXT_ZAKRES_3, ANSI_YELLOW );
				TFT_ILI9163C_PrintString_P( pozX, pozY, TXT_JEDNOSTKA_3, ANSI_YELLOW );
				break;
			}


			uint64_t static t1, t2;

			//NapiecieSDadc1 = PomiarSDadc1 * VREF_SDADC / 65535;				// (PomiarSDadc1 * VREF_SDADC) / (wzmocnienie * 65535);
			NapiecieSDadc1 = (((PomiarSDadc1) * VREF_SDADC) / (65535)); //  inputVoltageMv = (((InjectedConvData + 32768) * SDADC_VREF) / (SDADC_GAIN * SDADC_RESOL));


			char static txt[50];
			float wartosc;
#if POMIAR_ADC == 0
			wartosc = NapiecieAdc1;
#elif POMIAR_ADC == 1
			wartosc = NapiecieSDadc1;
#else
#error "Brak wyboru"
#endif
			switch( Zakres ){
			case 0: wartosc *= KALIBRACJA_DZIELNIKA_0; break;
			case 1: wartosc *= KALIBRACJA_DZIELNIKA_1; break;
			case 2: wartosc *= KALIBRACJA_DZIELNIKA_2; break;
			case 3: wartosc *= KALIBRACJA_DZIELNIKA_3; break;
			}
			wartDlaAuto = wartosc;


			TFT_ILI9163C_SetFont( 5, 7 );
			TFT_ILI9163C_PrintString_P( 60, 127-(3*8), (char*)_auth, ANSI_YELLOW );


			t1 = readTimSys();
			PrintWskaznik( wartosc );	// Wskazowka pod wyswietlaczem cyfrowym, nienaturalnie ale czytelniej
			t1 = readTimSys() - t1;

			switch( Zakres ){
//			case 0: sprintf( txt, "%.1f %s", wartosc * dzielWej, TXT_JEDNOSTKA_0 ); break;
//			case 0: sprintf( txt, "%d %s", (int)(wartosc * dzielWej), TXT_JEDNOSTKA_0 ); break;
			case 0: sprintf( txt, "%d %s", (int)(wartosc * dzielWej * 1000), TXT_JEDNOSTKA_0 ); break;
			case 1: sprintf( txt, "%.2f %s", wartosc * dzielWej, TXT_JEDNOSTKA_1 ); break;
			case 2: sprintf( txt, "%.1f %s", wartosc * dzielWej, TXT_JEDNOSTKA_2 ); break;
			case 3: sprintf( txt, "%d %s", (int)(wartosc * dzielWej), TXT_JEDNOSTKA_3 ); break;
			}
			//----- Zamiana kropki na przecinek
			char *p = strnstr( txt, ".", strlen(txt));
			if( p )	*p = ',';
			//----- Wyświetlenie
			TFT_ILI9163C_SetFont( 16, 16 );
			uint16_t color = ANSI_WHITE;
#ifdef DIGITAL_KOLOR
			if( (wartosc * dzielWej) >= WSKAZANIE_ZAKRES_KOLOR_R ) color = ANSI_RED;
			else if( (wartosc * dzielWej) >= WSKAZANIE_ZAKRES_KOLOR_G) color = ANSI_GREEN;
			else color = ANSI_YELLOW;
#endif
			TFT_ILI9163C_PrintString_BP( 50, 70, (char*)txt, color, ANSI_BLACK );


#ifdef DEBUG_LCD
			//uint32_t static cnt;
			//sprintf( txt, "Cnt=%d", (int)cnt++ );
			//TFT_ILI9163C_PrintString_P( 0, 32, (char*)txt, ANSI_YELLOW );

			sprintf( txt, "%04d %.5f", PomiarAdc1, NapiecieAdc1 );
			TFT_ILI9163C_PrintString_P( 0, 32, (char*)txt, ANSI_GREEN );

			sprintf( txt, "%d %.5f", (int)PomiarSDadc1, NapiecieSDadc1  );
			TFT_ILI9163C_PrintString_P( 0, 32+16, (char*)txt, ANSI_CYAN );

			sprintf( txt, "%d %d %dms", (int)t1, (int)t2, (int)timPomSDadc );
			TFT_ILI9163C_PrintString_P( 0, 32+16*2, (char*)txt, ANSI_RED );

			//float static wartosc;	// todo: test:
			//wartosc = wartosc + 0.01;
			//if( wartosc >= 1 ) wartosc = 0;
#endif


			t2 = readTimSys();
			TFT_ILI9163C_Display();	// TFT_ILI9163C_DisplayDMA();
			t2 = readTimSys() - t2;


			TRAP;
		}


    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
	}
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInit = {0};

  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI|RCC_OSCILLATORTYPE_LSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL16;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB busses clocks 
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_USART2|RCC_PERIPHCLK_ADC1
                              |RCC_PERIPHCLK_SDADC;
  PeriphClkInit.Usart2ClockSelection = RCC_USART2CLKSOURCE_PCLK1;
  PeriphClkInit.SdadcClockSelection = RCC_SDADCSYSCLK_DIV12;
  PeriphClkInit.Adc1ClockSelection = RCC_ADC1PCLK2_DIV2;

  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    Error_Handler();
  }
  HAL_PWREx_EnableSDADC(PWR_SDADC_ANALOG1);
}

/**
  * @brief ADC1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_ADC1_Init(void)
{

  /* USER CODE BEGIN ADC1_Init 0 */

  /* USER CODE END ADC1_Init 0 */

  ADC_ChannelConfTypeDef sConfig = {0};

  /* USER CODE BEGIN ADC1_Init 1 */

  /* USER CODE END ADC1_Init 1 */
  /** Common config 
  */
  hadc1.Instance = ADC1;
  hadc1.Init.ScanConvMode = ADC_SCAN_DISABLE;
  hadc1.Init.ContinuousConvMode = DISABLE;
  hadc1.Init.DiscontinuousConvMode = DISABLE;
  hadc1.Init.ExternalTrigConv = ADC_SOFTWARE_START;
  hadc1.Init.DataAlign = ADC_DATAALIGN_RIGHT;
  hadc1.Init.NbrOfConversion = 1;
  if (HAL_ADC_Init(&hadc1) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure Regular Channel 
  */
  sConfig.Channel = ADC_CHANNEL_0;
  sConfig.Rank = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_239CYCLES_5;
  if (HAL_ADC_ConfigChannel(&hadc1, &sConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN ADC1_Init 2 */

  /* USER CODE END ADC1_Init 2 */

}

/**
  * @brief IWDG Initialization Function
  * @param None
  * @retval None
  */
static void MX_IWDG_Init(void)
{

  /* USER CODE BEGIN IWDG_Init 0 */

  /* USER CODE END IWDG_Init 0 */

  /* USER CODE BEGIN IWDG_Init 1 */

  /* USER CODE END IWDG_Init 1 */
  hiwdg.Instance = IWDG;
  hiwdg.Init.Prescaler = IWDG_PRESCALER_16;
  hiwdg.Init.Window = 4095;
  hiwdg.Init.Reload = 4095;
  if (HAL_IWDG_Init(&hiwdg) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN IWDG_Init 2 */

  /* USER CODE END IWDG_Init 2 */

}

/**
  * @brief SDADC1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SDADC1_Init(void)
{

  /* USER CODE BEGIN SDADC1_Init 0 */

  /* USER CODE END SDADC1_Init 0 */

  SDADC_ConfParamTypeDef ConfParamStruct = {0};

  /* USER CODE BEGIN SDADC1_Init 1 */

  /* USER CODE END SDADC1_Init 1 */
  /** Configure the SDADC low power mode, fast conversion mode,
  slow clock mode and SDADC1 reference voltage 
  */
  hsdadc1.Instance = SDADC1;
  hsdadc1.Init.IdleLowPowerMode = SDADC_LOWPOWER_NONE;
  hsdadc1.Init.FastConversionMode = SDADC_FAST_CONV_DISABLE;
  hsdadc1.Init.SlowClockMode = SDADC_SLOW_CLOCK_DISABLE;
  hsdadc1.Init.ReferenceVoltage = SDADC_VREF_VREFINT1;
  if (HAL_SDADC_Init(&hsdadc1) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure The Regular Mode 
  */
  if (HAL_SDADC_SelectRegularTrigger(&hsdadc1, SDADC_SOFTWARE_TRIGGER) != HAL_OK)
  {
    Error_Handler();
  }
  /** Set parameters for SDADC configuration 0 Register 
  */
  ConfParamStruct.InputMode = SDADC_INPUT_MODE_SE_ZERO_REFERENCE;
  ConfParamStruct.Gain = SDADC_GAIN_1;
  ConfParamStruct.CommonMode = SDADC_COMMON_MODE_VSSA;
  ConfParamStruct.Offset = 0;
  if (HAL_SDADC_PrepareChannelConfig(&hsdadc1, SDADC_CONF_INDEX_0, &ConfParamStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure the Regular Channel 
  */
  if (HAL_SDADC_AssociateChannelConfig(&hsdadc1, SDADC_CHANNEL_7, SDADC_CONF_INDEX_0) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_SDADC_ConfigChannel(&hsdadc1, SDADC_CHANNEL_7, SDADC_CONTINUOUS_CONV_ON) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SDADC1_Init 2 */

  /* USER CODE END SDADC1_Init 2 */

}

/**
  * @brief SPI1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI1_Init(void)
{

  /* USER CODE BEGIN SPI1_Init 0 */

  /* USER CODE END SPI1_Init 0 */

  /* USER CODE BEGIN SPI1_Init 1 */

  /* USER CODE END SPI1_Init 1 */
  /* SPI1 parameter configuration*/
  hspi1.Instance = SPI1;
  hspi1.Init.Mode = SPI_MODE_MASTER;
  hspi1.Init.Direction = SPI_DIRECTION_2LINES;
  hspi1.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi1.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi1.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi1.Init.NSS = SPI_NSS_SOFT;
  hspi1.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_4;
  hspi1.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi1.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi1.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi1.Init.CRCPolynomial = 7;
  hspi1.Init.CRCLength = SPI_CRC_LENGTH_DATASIZE;
  hspi1.Init.NSSPMode = SPI_NSS_PULSE_ENABLE;
  if (HAL_SPI_Init(&hspi1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI1_Init 2 */

  /* USER CODE END SPI1_Init 2 */

}

/**
  * @brief TIM12 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM12_Init(void)
{

  /* USER CODE BEGIN TIM12_Init 0 */

  /* USER CODE END TIM12_Init 0 */

  TIM_ClockConfigTypeDef sClockSourceConfig = {0};
  TIM_OC_InitTypeDef sConfigOC = {0};

  /* USER CODE BEGIN TIM12_Init 1 */

  /* USER CODE END TIM12_Init 1 */
  htim12.Instance = TIM12;
  htim12.Init.Prescaler = 249;
  htim12.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim12.Init.Period = 255;
  htim12.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim12.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_ENABLE;
  if (HAL_TIM_Base_Init(&htim12) != HAL_OK)
  {
    Error_Handler();
  }
  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
  if (HAL_TIM_ConfigClockSource(&htim12, &sClockSourceConfig) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_TIM_PWM_Init(&htim12) != HAL_OK)
  {
    Error_Handler();
  }
  sConfigOC.OCMode = TIM_OCMODE_PWM1;
  sConfigOC.Pulse = 128;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
  sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
  if (HAL_TIM_PWM_ConfigChannel(&htim12, &sConfigOC, TIM_CHANNEL_2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM12_Init 2 */

  /* USER CODE END TIM12_Init 2 */
  HAL_TIM_MspPostInit(&htim12);

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 38400;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  huart2.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart2.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/** 
  * Enable DMA controller clock
  */
static void MX_DMA_Init(void) 
{

  /* DMA controller clock enable */
  __HAL_RCC_DMA1_CLK_ENABLE();

  /* DMA interrupt init */
  /* DMA1_Channel3_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel3_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel3_IRQn);
  /* DMA1_Channel7_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel7_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel7_IRQn);

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOE_CLK_ENABLE();
  __HAL_RCC_GPIOF_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, LCD_CS_Pin|D1000_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(D100_GPIO_Port, D100_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(D10_GPIO_Port, D10_Pin, GPIO_PIN_SET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(LCD_A0_GPIO_Port, LCD_A0_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin : LCD_CS_Pin */
  GPIO_InitStruct.Pin = LCD_CS_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(LCD_CS_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : D1000_Pin */
  GPIO_InitStruct.Pin = D1000_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(D1000_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : D100_Pin */
  GPIO_InitStruct.Pin = D100_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(D100_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : D10_Pin */
  GPIO_InitStruct.Pin = D10_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_OD;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(D10_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pin : LCD_A0_Pin */
  GPIO_InitStruct.Pin = LCD_A0_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(LCD_A0_GPIO_Port, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
	/* User can add his own implementation to report the HAL error return state */


	//todo:
	TRAP;


  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(char *file, uint32_t line)
{ 
  /* USER CODE BEGIN 6 */
	/* User can add his own implementation to report the file name and line number,
     tex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
